// class Matrix   
//     -

#ifndef MATRIXH
#define MATRIXH

//#include <iostream.h>
#include "Vector.h"

class Matrix{
  int row, col ;    //    
public:
  Matrix(int n = 1,int m = 1);  //
  Matrix(const Matrix&);        // 
  ~Matrix();                    //
  Matrix& operator=(const Matrix&); // 

  double& ElemM(int i, int j)   //   
  {return (*a[j - 1]).v[i - 1];}
  Matrix operator~();           // 

  //   
  friend ostream& operator<<(ostream&, const Matrix&);
  //   
  friend istream& operator>>(istream&, Matrix&);
  Matrix operator+(const Matrix&);  // 
  Matrix operator-(const Matrix&);  // 
  Matrix& operator*(const double);  //   
  Matrix& operator-();              //  -  
  int operator==(const Matrix&);    //   
  int operator!=(const Matrix&);    //  
  Matrix operator*(const Matrix&);  //   
  Vector operator*(const Vector&);  //   
private:
//    - ,  
  Vector **a;
  void SwapLines(int i, int j); //  
  void MakeMain(int i);     // i-   
  void DivLine(int i, double divisor);// i-   divisor
//  k-  i- ,   factor
  void DiffLines(int k, int i, double factor);
  Vector GetLine(int i);// i-  
};

#endif