// Vector   
 
#ifndef VECTORH
#define VECTORH

#include <iostream.h>

class Vector {
  double* v;    //  
  int size;     //  ;
public:
  friend class Matrix;  //   
  Vector(int r=1);      //
  Vector(const Vector&);// 
  ~Vector()             //
  {delete[] v;}

  double& operator[](int i) //  
  {return v[i];}
  double& ElemV(int i)      //  
  {return v[i - 1];}

//     

  friend ostream& operator<<(ostream&, const Vector&);
  friend istream& operator>>(istream&, Vector&);

//  /     

  friend ostream& operator<<(ostream&, const Matrix&);
  friend istream& operator>>(istream&,Matrix&);

  Vector& operator=(const Vector&);     // 
  Vector operator+(const Vector&);      // 
  Vector operator-(const Vector&);      // 
  Vector& operator*(const double);      //   
  Vector& operator-();                  // 

  int operator==(const Vector&)const;   //   
  int operator!=(const Vector&)const;   //  

  double operator*(const Vector&)const; // 

  double norma()const;                  // 

  friend double V_cos(const Vector&,const Vector&); // 

                                                    // 

  int NumbMainElement(int i);//    

                //,       i

};

#endif